https://leetcode.com/problems/longest-increasing-subsequence/description/
Given an unsorted array of integers, find the length of longest increasing subsequence.
For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.
Your algorithm should run in O(n2) complexity.
Follow up: Could you improve it to O(n log n) time complexity?
解题思路:
求最长递增子序列
dp[i]表示当前索引的最长递增子序列的长度
状态转移方程
dp[i]=dp[i] if(nums[i]<nums[j],i>j)
dp[i]=dp[j]+1 if(nums[i]>nums[j]&&dp[i]<dp[j]+1)
边界
dp[i]=1
public class Longest_Increasing_Subsequence_300 {
/**
* 求最长递增自序列
* dp[i]表示当前索引的最长递增子序列的长度
* dp[i]=dp[i] if(nums[i]<nums[j],i>j)
* dp[i]=dp[j]+1 if(nums[i]>nums[j]&&dp[i]<dp[j]+1)
* 边界dp[0]=0,dp[1]=1
* @param nums
* @return
*/
public int lengthOfLIS(int[] nums) {
if(nums==null||nums.length==0)return 0;
int n = nums.length;
int[] dp = new int[n+1];
int max = 0;
for(int i=0;i<n;i++){
//每个子问题最短也为1
dp[i]=1;
for(int j=0;j<i;j++){
if(nums[i]>nums[j]&&dp[i]<dp[j]+1){
dp[i] = dp[j] + 1;
}
}
if(dp[i]>max)max = dp[i];
}
return max;
}
public static void main(String[] args) {
new Longest_Increasing_Subsequence_300().lengthOfLIS(new int[]{1,3,6,7,9,4,10,5,6});
}
}